OGRE: Ogre::MetalTexture Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Ogre::MetalTexture Class Reference

`#include <OgreMetalTexture.h>`

Inheritance diagram for Ogre::MetalTexture:
[legend]

## Public Types
enum | LoadingFlags { LF_DEFAULT = 0, LF_INCLUDE_NON_RELOADABLE = 1, LF_ONLY_UNREFERENCED = 2, LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3, LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING, LOADSTATE_PREPARED, LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...

## Public Member Functions
| MetalTexture (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual, ManualResourceLoader *loader, MetalDevice *device)
virtual | ~MetalTexture ()
virtual void | _autogenerateMipmaps (void)
| Tells the API to let the HW autogenerate mipmaps. More...
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed. More...
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event. More...
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event. More...
virtual void | _fireUnloadingComplete (void)
| Firing of unloading complete event. More...
virtual void | _loadImages (const ConstImagePtrList &images)
| Internal method to load the texture from a set of images. More...
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin. More...
virtual void | addListener (Listener *lis)
| Register a listener on this resource. More...
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource. More...
virtual void | convertToImage (Image &destImage, bool includeMipMaps=false, uint32 mipmapBias=0, uint32 zOrSliceStart=0, uint32 depthOrSlices=0)
| Populate an Image with the contents of this texture. More...
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object. More...
virtual void | copyToTexture (TexturePtr &target)
| Copies (and maybe scales to fit) the contents of this texture to another texture. More...
virtual void | createInternalResources (void)
| Creates the internal texture resources for this texture. More...
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource. More...
virtual void | freeInternalResources (void)
| Frees internal texture resources for this texture. More...
virtual v1::HardwarePixelBufferSharedPtr | getBuffer (size_t face, size_t mipmap)
| Return hardware pixel buffer for a surface. More...
virtual ResourceManager * | getCreator (void)
| Gets the manager which created this resource. More...
virtual void | getCustomAttribute (const String &name, void *pData)
| Retrieve a platform or API-specific piece of information from this texture. More...
uint32 | getDepth (void) const
| Returns the depth of the texture (only applicable for 3D textures). More...
virtual ushort | getDesiredFloatBitDepth (void) const
| gets desired bit depth for float pixel format textures. More...
PixelFormat | getDesiredFormat (void) const
| Returns the desired pixel format for the texture surface. More...
virtual ushort | getDesiredIntegerBitDepth (void) const
| gets desired bit depth for integer pixel format textures. More...
PixelFormat | getFormat () const
| Returns the pixel format for the texture surface. More...
virtual uint | getFSAA () const
| Get the level of multisample AA to be used if this texture is a rendertarget. More...
virtual const String & | getFSAAHint () const
| Get the multisample AA hint if this texture is a rendertarget. More...
float | getGamma (void) const
| Returns the gamma adjustment factor applied to this texture on loading. More...
virtual const String & | getGroup (void) const
| Gets the group which this resource is a member of. More...
virtual ResourceHandle | getHandle (void) const
uint32 | getHeight (void) const
| Returns the height of the texture. More...
virtual LoadingState | getLoadingState () const
| Returns the current loading state. More...
bool | getMipmapsHardwareGenerated (void) const
| Are mipmaps hardware generated? More...
virtual const String & | getName (void) const
| Gets resource name. More...
virtual size_t | getNumFaces () const
| Return the number of faces this texture has. More...
uint8 | getNumMipmaps (void) const
| Gets the number of mipmaps to be used for this texture. More...
virtual const String & | getOrigin (void) const
| Get the origin of this resource, e.g. More...
MetalDevice * | getOwnerDevice (void) const
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class. More...
const ParamDictionary * | getParamDictionary (void) const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method. More...
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object. More...
virtual size_t | getSize (void) const
| Retrieves info about the size of the resource. More...
uint32 | getSrcDepth (void) const
| Returns the original depth of the input texture (only applicable for 3D textures). More...
PixelFormat | getSrcFormat (void) const
| Returns the pixel format of the original input texture (may differ due to hardware requirements and pixel format conversion). More...
uint32 | getSrcHeight (void) const
| Returns the height of the original input texture (may differ due to hardware requirements). More...
uint32 | getSrcWidth (void) const
| Returns the width of the original input texture (may differ due to hardware requirements). More...
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded. More...
id< MTLTexture > | getTextureForSampling (MetalRenderSystem *renderSystem)
TextureType | getTextureType (void) const
| Gets the type of texture. More...
virtual bool | getTreatLuminanceAsAlpha (void) const
| Gets whether luminace pixel format will treated as alpha format when load this texture. More...
virtual int | getUsage () const
| Returns the TextureUsage identifier for this Texture. More...
uint32 | getWidth (void) const
| Returns the width of the texture. More...
virtual bool | hasAlpha (void) const
| Returns true if the texture has an alpha layer. More...
virtual bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading. More...
virtual bool | isHardwareGammaEnabled () const
| Gets whether this texture will be set up so that on sampling it, hardware gamma correction is applied. More...
virtual bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise. More...
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading. More...
virtual bool | isManuallyLoaded (void) const
| Is this resource manually loaded? More...
virtual bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise. More...
virtual bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise. More...
bool | isTextureTypeArray (void) const
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already. More...
virtual void | loadImage (const Image &img)
| Loads the data from an image. More...
virtual void | loadRawData (DataStreamPtr &stream, ushort uWidth, ushort uHeight, PixelFormat eFormat)
| Loads the data from a raw stream. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already. More...
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded. More...
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource. More...
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not. More...
void | setDepth (uint32 d)
| Set the depth of the texture (only applicable for 3D textures); can only do this before load();. More...
virtual void | setDesiredBitDepths (ushort integerBits, ushort floatBits)
| Sets desired bit depth for integer and float pixel format. More...
virtual void | setDesiredFloatBitDepth (ushort bits)
| Sets desired bit depth for float pixel format textures. More...
virtual void | setDesiredIntegerBitDepth (ushort bits)
| Sets desired bit depth for integer pixel format textures. More...
virtual void | setFormat (PixelFormat pf)
| Sets the pixel format for the texture surface; can only be set before load(). More...
virtual void | setFSAA (uint fsaa, const String &fsaaHint, bool explicitResolve)
| Set the level of multisample AA to be used if this texture is a rendertarget. More...
void | setGamma (float g)
| Sets the gamma adjustment factor applied to this texture on loading the data. More...
void | setHardwareGammaEnabled (bool enabled)
| Sets whether this texture will be set up so that on sampling it, hardware gamma correction is applied. More...
void | setHeight (uint32 h)
| Set the height of the texture; can only do this before load();. More...
virtual void | setManuallyLoaded (bool isManual)
| Set "Is this resource manually loaded?". More...
void | setNumMipmaps (uint8 num)
| Sets the number of mipmaps to be used for this texture. More...
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method. More...
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method. More...
void | setTextureType (TextureType ttype)
| Sets the type of texture; can only be changed before load() More...
virtual void | setToLoaded (void)
| Change the Resource loading state to loaded. More...
virtual void | setTreatLuminanceAsAlpha (bool asAlpha)
| Sets whether luminace pixel format will treated as alpha format when load this texture. More...
virtual void | setUsage (int u)
| Sets the TextureUsage identifier for this Texture; only useful before load() More...
void | setWidth (uint32 w)
| Set the width of the texture; can only do this before load();. More...
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used. More...
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required. More...

## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. More...

## Public Attributes
| OGRE_AUTO_MUTEX

## Member Enumeration Documentation

## ◆ LoadingFlags

enum Ogre::Resource::LoadingFlags
| inherited

Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior.

Enumerator
LF_DEFAULT | Only reloadable resources are processed, reload restores initial state.
LF_INCLUDE_NON_RELOADABLE | Process non-reloadable resources too.
LF_ONLY_UNREFERENCED | Process only resources which are not referenced by any other object. Usefull to reduce resource consumption.
LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE | Combination of LF_ONLY_UNREFERENCED and LF_INCLUDE_NON_RELOADABLE.
LF_PRESERVE_STATE | Preserve some states during reloading, for example stencil shadows prepareness for Meshes.

## ◆ LoadingState

enum Ogre::Resource::LoadingState
| inherited

Enum identifying the loading state of the resource.

Enumerator
LOADSTATE_UNLOADED | Not loaded.
LOADSTATE_LOADING | Loading is in progress.
LOADSTATE_LOADED | Fully loaded.
LOADSTATE_UNLOADING | Currently unloading.
LOADSTATE_PREPARED | Fully prepared.
LOADSTATE_PREPARING | Preparing is in progress.

## Constructor & Destructor Documentation

## ◆ MetalTexture()

Ogre::MetalTexture::MetalTexture | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual,
|  | ManualResourceLoader * | loader,
|  | MetalDevice * | device
| ) |  |

## ◆ ~MetalTexture()

virtual Ogre::MetalTexture::~MetalTexture | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _autogenerateMipmaps()

virtual void Ogre::MetalTexture::_autogenerateMipmaps | ( | void |  | ) |
| virtual

Tells the API to let the HW autogenerate mipmaps.

Assumes the texture is of usage TU_RENDERTARGET & TU_AUTOMIPMAP

Implements Ogre::Texture.

Reimplemented in Ogre::MetalNullTexture.

## ◆ _dirtyState()

virtual void Ogre::Resource::_dirtyState | ( |  | ) |
| virtualinherited

Manually mark the state of this resource as having been changed.

Remarks
  You only need to call this from outside if you explicitly want derived objects to think this object has changed.

See also
  getStateCount.

## ◆ _fireLoadingComplete()

virtual void Ogre::Resource::_fireLoadingComplete | ( | bool | wasBackgroundLoaded | ) |
| virtualinherited

Firing of loading complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters

  wasBackgroundLoaded | Whether this was a background loaded event

## ◆ _firePreparingComplete()

virtual void Ogre::Resource::_firePreparingComplete | ( | bool | wasBackgroundLoaded | ) |
| virtualinherited

Firing of preparing complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters

  wasBackgroundLoaded | Whether this was a background loaded event

## ◆ _fireUnloadingComplete()

virtual void Ogre::Resource::_fireUnloadingComplete | ( | void |  | ) |
| virtualinherited

Firing of unloading complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

## ◆ _loadImages()

virtual void Ogre::Texture::_loadImages | ( | const ConstImagePtrList & | images | ) |
| virtualinherited

Internal method to load the texture from a set of images.

Note
  Do NOT call this method unless you are inside the load() routine already, e.g. a ManualResourceLoader. It is not threadsafe and does not check or update resource loading status.

## ◆ _notifyOrigin()

virtual void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) |
| inlinevirtualinherited

Notify this resource of it's origin.

## ◆ addListener()

virtual void Ogre::Resource::addListener | ( | Listener * | lis | ) |
| virtualinherited

Register a listener on this resource.

See also
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ changeGroupOwnership()

virtual void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) |
| virtualinherited

Change the resource group ownership of a Resource.

Remarks
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters

  newGroup | Name of the new group

## ◆ cleanupDictionary()

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| staticinherited

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

## ◆ convertToImage()

virtual void Ogre::Texture::convertToImage | ( | Image & | destImage,
|  | bool | includeMipMaps = `false`,
|  | uint32 | mipmapBias = `0`,
|  | uint32 | zOrSliceStart = `0`,
|  | uint32 | depthOrSlices = `0`
| ) |  |
| virtualinherited

Populate an Image with the contents of this texture.

Parameters

  destImage | The target image (contents will be overwritten)
  includeMipMaps | Whether to embed mipmaps in the image
  mipmapBias | From which mipmap we should start from; in range [0; getNumMipmaps()]
  zOrSliceStart | First slice to use. Only valid for 2D Array, 3D and Cubemap textures
  depthOrSlices | Number of slices to export. Only valid for 2D Array, 3D and Cubemap textures. A value of 0 means all of them starting from firstSlice.

## ◆ copyParametersTo()

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inlinevirtualinherited

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References Ogre::StringInterface::setParameter().

## ◆ copyToTexture()

virtual void Ogre::Texture::copyToTexture | ( | TexturePtr & | target | ) |
| virtualinherited

Copies (and maybe scales to fit) the contents of this texture to another texture.

Reimplemented in Ogre::D3D9Texture, and Ogre::D3D11Texture.

## ◆ createInternalResources()

virtual void Ogre::Texture::createInternalResources | ( | void |  | ) |
| virtualinherited

Creates the internal texture resources for this texture.

Remarks
  This method creates the internal texture resources (pixel buffers, texture surfaces etc) required to begin using this texture. You do not need to call this method directly unless you are manually creating a texture, in which case something must call it, after having set the size and format of the texture (e.g. the ManualResourceLoader might be the best one to call it). If you are not defining a manual texture, or if you use one of the self-contained load...() methods, then it will be called for you.

Reimplemented in Ogre::MetalNullTexture, Ogre::D3D11NullTexture, and Ogre::D3D11DepthTexture.

## ◆ escalateLoading()

virtual void Ogre::Resource::escalateLoading | ( |  | ) |
| virtualinherited

Escalates the loading of a background loaded resource.

Remarks
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ freeInternalResources()

virtual void Ogre::Texture::freeInternalResources | ( | void |  | ) |
| virtualinherited

Frees internal texture resources for this texture.

Reimplemented in Ogre::MetalNullTexture, Ogre::D3D11NullTexture, and Ogre::D3D11DepthTexture.

## ◆ getBuffer()

virtual v1::HardwarePixelBufferSharedPtr Ogre::MetalTexture::getBuffer | ( | size_t | face,
|  | size_t | mipmap
| ) |  |
| virtual

Return hardware pixel buffer for a surface.

This buffer can then be used to copy data from and to a particular level of the texture.

Parameters

  face | Face number, in case of a cubemap texture. Must be 0 for other types of textures. For cubemaps, this is one of +X (0), -X (1), +Y (2), -Y (3), +Z (4), -Z (5)
  mipmap | Mipmap level. This goes from 0 for the first, largest mipmap level to getNumMipmaps()-1 for the smallest.

Returns
  A shared pointer to a hardware pixel buffer

Remarks
  The buffer is invalidated when the resource is unloaded or destroyed. Do not use it after the lifetime of the containing texture.

Implements Ogre::Texture.

## ◆ getCreator()

virtual ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) |
| inlinevirtualinherited

Gets the manager which created this resource.

## ◆ getCustomAttribute()

virtual void Ogre::Texture::getCustomAttribute | ( | const String & | name,
|  | void * | pData
| ) |  |
| virtualinherited

Retrieve a platform or API-specific piece of information from this texture.

This method of retrieving information should only be used if you know what you're doing.

Parameters

  name | The name of the attribute to retrieve
  pData | Pointer to memory matching the type of data you want to retrieve.

Reimplemented in Ogre::GL3PlusTexture.

## ◆ getDepth()

uint32 Ogre::Texture::getDepth | ( | void |  | ) | const
| inlineinherited

Returns the depth of the texture (only applicable for 3D textures).

## ◆ getDesiredFloatBitDepth()

virtual ushort Ogre::Texture::getDesiredFloatBitDepth | ( | void |  | ) | const
| virtualinherited

gets desired bit depth for float pixel format textures.

## ◆ getDesiredFormat()

PixelFormat Ogre::Texture::getDesiredFormat | ( | void |  | ) | const
| inlineinherited

Returns the desired pixel format for the texture surface.

## ◆ getDesiredIntegerBitDepth()

virtual ushort Ogre::Texture::getDesiredIntegerBitDepth | ( | void |  | ) | const
| virtualinherited

gets desired bit depth for integer pixel format textures.

## ◆ getFormat()

PixelFormat Ogre::Texture::getFormat | ( | void |  | ) | const
| inlineinherited

Returns the pixel format for the texture surface.

## ◆ getFSAA()

virtual uint Ogre::Texture::getFSAA | ( |  | ) | const
| inlinevirtualinherited

Get the level of multisample AA to be used if this texture is a rendertarget.

## ◆ getFSAAHint()

virtual const String& Ogre::Texture::getFSAAHint | ( |  | ) | const
| inlinevirtualinherited

Get the multisample AA hint if this texture is a rendertarget.

## ◆ getGamma()

float Ogre::Texture::getGamma | ( | void |  | ) | const
| inlineinherited

Returns the gamma adjustment factor applied to this texture on loading.

## ◆ getGroup()

virtual const String& Ogre::Resource::getGroup | ( | void |  | ) | const
| inlinevirtualinherited

Gets the group which this resource is a member of.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getHandle()

virtual ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const
| inlinevirtualinherited

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getHeight()

uint32 Ogre::Texture::getHeight | ( | void |  | ) | const
| inlineinherited

Returns the height of the texture.

## ◆ getLoadingState()

virtual LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const
| inlinevirtualinherited

Returns the current loading state.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ getMipmapsHardwareGenerated()

bool Ogre::Texture::getMipmapsHardwareGenerated | ( | void |  | ) | const
| inlineinherited

Are mipmaps hardware generated?

Remarks
  Will only be accurate after texture load, or createInternalResources

## ◆ getName()

virtual const String& Ogre::Resource::getName | ( | void |  | ) | const
| inlinevirtualinherited

Gets resource name.

Reimplemented in Ogre::v1::OldSkeletonInstance.

Referenced by Ogre::GpuProgramUsage::getProgramName().

## ◆ getNumFaces()

virtual size_t Ogre::Texture::getNumFaces | ( |  | ) | const
| virtualinherited

Return the number of faces this texture has.

This will be 6 for a cubemap texture and 1 for a 1D, 2D or 3D one.

## ◆ getNumMipmaps()

uint8 Ogre::Texture::getNumMipmaps | ( | void |  | ) | const
| inlineinherited

Gets the number of mipmaps to be used for this texture.

## ◆ getOrigin()

virtual const String& Ogre::Resource::getOrigin | ( | void |  | ) | const
| inlinevirtualinherited

Get the origin of this resource, e.g.

a script file name.

Remarks
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

## ◆ getOwnerDevice()

MetalDevice* Ogre::MetalTexture::getOwnerDevice | ( | void |  | ) | const
| inline

## ◆ getParamDictionary() [1/2]

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |
| inlineinherited

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

## ◆ getParamDictionary() [2/2]

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const
| inlineinherited

## ◆ getParameter()

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inlinevirtualinherited

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References Ogre::ParamCommand::doGet().

## ◆ getParameters()

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const
| inherited

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ getSize()

virtual size_t Ogre::Resource::getSize | ( | void |  | ) | const
| inlinevirtualinherited

Retrieves info about the size of the resource.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getSrcDepth()

uint32 Ogre::Texture::getSrcDepth | ( | void |  | ) | const
| inlineinherited

Returns the original depth of the input texture (only applicable for 3D textures).

## ◆ getSrcFormat()

PixelFormat Ogre::Texture::getSrcFormat | ( | void |  | ) | const
| inlineinherited

Returns the pixel format of the original input texture (may differ due to hardware requirements and pixel format conversion).

## ◆ getSrcHeight()

uint32 Ogre::Texture::getSrcHeight | ( | void |  | ) | const
| inlineinherited

Returns the height of the original input texture (may differ due to hardware requirements).

## ◆ getSrcWidth()

uint32 Ogre::Texture::getSrcWidth | ( | void |  | ) | const
| inlineinherited

Returns the width of the original input texture (may differ due to hardware requirements).

## ◆ getStateCount()

virtual size_t Ogre::Resource::getStateCount | ( |  | ) | const
| inlinevirtualinherited

Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.

Objects that build derived data based on the resource can check this value against a copy they kept last time they built this derived data, in order to know whether it needs rebuilding. This is a nice way of monitoring changes without having a tightly-bound callback.

## ◆ getTextureForSampling()

id<MTLTexture> Ogre::MetalTexture::getTextureForSampling | ( | MetalRenderSystem * | renderSystem | ) |

## ◆ getTextureType()

TextureType Ogre::Texture::getTextureType | ( | void |  | ) | const
| inlineinherited

Gets the type of texture.

## ◆ getTreatLuminanceAsAlpha()

virtual bool Ogre::Texture::getTreatLuminanceAsAlpha | ( | void |  | ) | const
| virtualinherited

Gets whether luminace pixel format will treated as alpha format when load this texture.

## ◆ getUsage()

virtual int Ogre::Texture::getUsage | ( |  | ) | const
| inlinevirtualinherited

Returns the TextureUsage identifier for this Texture.

## ◆ getWidth()

uint32 Ogre::Texture::getWidth | ( | void |  | ) | const
| inlineinherited

Returns the width of the texture.

## ◆ hasAlpha()

virtual bool Ogre::Texture::hasAlpha | ( | void |  | ) | const
| virtualinherited

Returns true if the texture has an alpha layer.

## ◆ isBackgroundLoaded()

virtual bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether this Resource has been earmarked for background loading.

Remarks
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isHardwareGammaEnabled()

virtual bool Ogre::Texture::isHardwareGammaEnabled | ( |  | ) | const
| inlinevirtualinherited

Gets whether this texture will be set up so that on sampling it, hardware gamma correction is applied.

Referenced by Ogre::NULLTexture::getBuffer().

## ◆ isLoaded()

virtual bool Ogre::Resource::isLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource has been loaded, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ isLoading()

virtual bool Ogre::Resource::isLoading | ( |  | ) | const
| inlinevirtualinherited

Returns whether the resource is currently in the process of background loading.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ isManuallyLoaded()

virtual bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Is this resource manually loaded?

## ◆ isPrepared()

virtual bool Ogre::Resource::isPrepared | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource has been prepared, false otherwise.

References Ogre::AtomicScalar< T >::get().

## ◆ isReloadable()

virtual bool Ogre::Resource::isReloadable | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource is reloadable, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isTextureTypeArray()

bool Ogre::Texture::isTextureTypeArray | ( | void |  | ) | const
| inlineinherited

References Ogre::TEX_TYPE_2D_ARRAY.

## ◆ load()

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) |
| virtualinherited

Loads the resource, if it is not already.

Remarks
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters

  backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ loadImage()

virtual void Ogre::Texture::loadImage | ( | const Image & | img | ) |
| virtualinherited

Loads the data from an image.

Note
  Important: only call this from outside the load() routine of a Resource. Don't call it within (including ManualResourceLoader) - use _loadImages() instead. This method is designed to be external, performs locking and checks the load status before loading.

Reimplemented in Ogre::MetalNullTexture, Ogre::D3D11Texture, Ogre::D3D11NullTexture, and Ogre::D3D11DepthTexture.

## ◆ loadRawData()

virtual void Ogre::Texture::loadRawData | ( | DataStreamPtr & | stream,
|  | ushort | uWidth,
|  | ushort | uHeight,
|  | PixelFormat | eFormat
| ) |  |
| virtualinherited

Loads the data from a raw stream.

Note
  Important: only call this from outside the load() routine of a Resource. Don't call it within (including ManualResourceLoader) - use _loadImages() instead. This method is designed to be external, performs locking and checks the load status before loading.

Parameters

  stream | Data stream containing the raw pixel data
  uWidth | Width of the image
  uHeight | Height of the image
  eFormat | The format of the pixel data

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ prepare()

virtual void Ogre::Resource::prepare | ( | bool | backgroundThread = `false` | ) |
| virtualinherited

Prepares the resource for load, if it is not already.

One can call prepare() before load(), but this is not required as load() will call prepare() itself, if needed. When OGRE_THREAD_SUPPORT==1 both load() and prepare() are thread-safe. When OGRE_THREAD_SUPPORT==2 however, only prepare() is thread-safe. The reason for this function is to allow a background thread to do some of the loading work, without requiring the whole render system to be thread-safe. The background thread would call prepare() while the main render loop would later call load(). So long as prepare() remains thread-safe, subclasses can arbitrarily split the work of loading a resource between load() and prepare(). It is best to try and do as much work in prepare(), however, since this will leave less work for the main render thread to do and thus increase FPS.

Parameters

  backgroundThread | Whether this is occurring in a background thread

## ◆ reload()

virtual void Ogre::Resource::reload | ( | LoadingFlags | flags = `LF_DEFAULT` | ) |
| virtualinherited

Reloads the resource, if it is already loaded.

Remarks
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram, and Ogre::v1::Mesh.

## ◆ removeListener()

virtual void Ogre::Resource::removeListener | ( | Listener * | lis | ) |
| virtualinherited

Remove a listener on this resource.

See also
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ setBackgroundLoaded()

virtual void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) |
| inlinevirtualinherited

Tells the resource whether it is background loaded or not.

Remarks

See also
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ setDepth()

void Ogre::Texture::setDepth | ( | uint32 | d | ) |
| inlineinherited

Set the depth of the texture (only applicable for 3D textures); can only do this before load();.

## ◆ setDesiredBitDepths()

virtual void Ogre::Texture::setDesiredBitDepths | ( | ushort | integerBits,
|  | ushort | floatBits
| ) |  |
| virtualinherited

Sets desired bit depth for integer and float pixel format.

## ◆ setDesiredFloatBitDepth()

virtual void Ogre::Texture::setDesiredFloatBitDepth | ( | ushort | bits | ) |
| virtualinherited

Sets desired bit depth for float pixel format textures.

Note
  Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for a channel of the pixel.

## ◆ setDesiredIntegerBitDepth()

virtual void Ogre::Texture::setDesiredIntegerBitDepth | ( | ushort | bits | ) |
| virtualinherited

Sets desired bit depth for integer pixel format textures.

Note
  Available values: 0, 16 and 32, where 0 (the default) means keep original format as it is. This value is number of bits for the pixel.

## ◆ setFormat()

virtual void Ogre::Texture::setFormat | ( | PixelFormat | pf | ) |
| virtualinherited

Sets the pixel format for the texture surface; can only be set before load().

## ◆ setFSAA()

virtual void Ogre::Texture::setFSAA | ( | uint | fsaa,
|  | const String & | fsaaHint,
|  | bool | explicitResolve
| ) |  |
| inlinevirtualinherited

Set the level of multisample AA to be used if this texture is a rendertarget.

Note
  This option will be ignored if TU_RENDERTARGET is not part of the usage options on this texture, or if the hardware does not support it.

Parameters

  fsaa | The number of samples
  fsaaHint | Any hinting text (

See also
  Root::createRenderWindow)

Parameters

  explicitResolve | @See TextureDefinitionBase::TextureDefinition::fsaaExplicitResolve

## ◆ setGamma()

void Ogre::Texture::setGamma | ( | float | g | ) |
| inlineinherited

Sets the gamma adjustment factor applied to this texture on loading the data.

Note
  Must be called before any 'load' method. This gamma factor will be premultiplied in and may reduce the precision of your textures. You can use setHardwareGamma if supported to apply gamma on sampling the texture instead.

## ◆ setHardwareGammaEnabled()

void Ogre::Texture::setHardwareGammaEnabled | ( | bool | enabled | ) |
| inlineinherited

Sets whether this texture will be set up so that on sampling it, hardware gamma correction is applied.

Remarks
  24-bit textures are often saved in gamma colour space; this preserves precision in the 'darks'. However, if you're performing blending on the sampled colours, you really want to be doing it in linear space. One way is to apply a gamma correction value on loading (see setGamma), but this means you lose precision in those dark colours. An alternative is to get the hardware to do the gamma correction when reading the texture and converting it to a floating point value for the rest of the pipeline. This option allows you to do that; it's only supported in relatively recent hardware (others will ignore it) but can improve the quality of colour reproduction.

Note
  Must be called before any 'load' method since it may affect the construction of the underlying hardware resources. Also note this only useful on textures using 8-bit colour channels.

## ◆ setHeight()

void Ogre::Texture::setHeight | ( | uint32 | h | ) |
| inlineinherited

Set the height of the texture; can only do this before load();.

## ◆ setManuallyLoaded()

virtual void Ogre::Resource::setManuallyLoaded | ( | bool | isManual | ) |
| inlinevirtualinherited

Set "Is this resource manually loaded?".

## ◆ setNumMipmaps()

void Ogre::Texture::setNumMipmaps | ( | uint8 | num | ) |
| inlineinherited

Sets the number of mipmaps to be used for this texture.

Note
  Must be set before calling any 'load' method.

## ◆ setParameter()

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) |  |
| virtualinherited

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

## ◆ setParameterList()

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| virtualinherited

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

## ◆ setTextureType()

void Ogre::Texture::setTextureType | ( | TextureType | ttype | ) |
| inlineinherited

Sets the type of texture; can only be changed before load()

## ◆ setToLoaded()

virtual void Ogre::Resource::setToLoaded | ( | void |  | ) |
| inlinevirtualinherited

Change the Resource loading state to loaded.

References Ogre::AtomicScalar< T >::set().

## ◆ setTreatLuminanceAsAlpha()

virtual void Ogre::Texture::setTreatLuminanceAsAlpha | ( | bool | asAlpha | ) |
| virtualinherited

Sets whether luminace pixel format will treated as alpha format when load this texture.

## ◆ setUsage()

virtual void Ogre::Texture::setUsage | ( | int | u | ) |
| inlinevirtualinherited

Sets the TextureUsage identifier for this Texture; only useful before load()

Parameters

  u | is a combination of TU_STATIC, TU_DYNAMIC, TU_WRITE_ONLY TU_AUTOMIPMAP and TU_RENDERTARGET (see TextureUsage enum). You are strongly advised to use HBU_STATIC_WRITE_ONLY wherever possible, if you need to update regularly, consider HBU_DYNAMIC_WRITE_ONLY.

## ◆ setWidth()

void Ogre::Texture::setWidth | ( | uint32 | w | ) |
| inlineinherited

Set the width of the texture; can only do this before load();.

## ◆ touch()

virtual void Ogre::Resource::touch | ( | void |  | ) |
| virtualinherited

'Touches' the resource to indicate it has been used.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram, and Ogre::Material.

Referenced by Ogre::Material::touch().

## ◆ unload()

virtual void Ogre::Resource::unload | ( | void |  | ) |
| virtualinherited

Unloads the resource; this is not permanent, the resource can be reloaded later if required.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## Member Data Documentation

## ◆ OGRE_AUTO_MUTEX

Ogre::Resource::OGRE_AUTO_MUTEX
| inherited

The documentation for this class was generated from the following file:

- OgreMetalTexture.h